#!/usr/bin/env ruby
#
#== DCModelF90SampleMaker 饹Υåץ
#
#Authors::   Yasuhiro MORIKAWA
#Version::   $Id: dcmodel_f90sample_maker-test.rb,v 1.22 2007/07/31 02:38:13 morikawa Exp $
#Tag Name::  $Name: dcpam4-20070731 $
#Copyright:: Copyright (C) GFD Dennou Club, 2007-. All rights reserved.
#License::   See COPYRIGHT[link:../../COPYRIGHT]
#

# Test::Unit
require "test/unit"
require "dcmodel_f90sample_maker"

# DCModelF90SampleMaker Υƥȥ饹.
class TestDCModelF90SampleMaker < Test::Unit::TestCase

  def setup
  end

  # def teardown
  # end

  #GNUMakefileParser#new Υƥ
  def test_s_new
    assert_raise(ArgumentError) {
      dcsample0 = DCModelF90SampleMaker.new
    }
    assert_raise(ArgumentError) {
      dcsample0 = DCModelF90SampleMaker.new('hoge')
    }
    assert_nothing_raised {
      dcsample0 = DCModelF90SampleMaker.new('procedure')
    }
    assert_nothing_raised {
      dcsampleproc0 = DCModelF90SampleMaker::DCModelF90SampleProcMaker.new
    }
    assert_raise(ArgumentError) {
      dcsampleproc0 = DCModelF90SampleMaker::DCModelF90SampleProcMaker.new('hogehoge')
    }
    assert_nothing_raised {
      dcsampleproc0 = DCModelF90SampleMaker::DCModelF90SampleProcMaker.new('create')
      dcsampleproc0 = DCModelF90SampleMaker::DCModelF90SampleProcMaker.new('close')
    }

    dcsample1 = DCModelF90SampleMaker.new('procedure')
    dcsampleproc1 = DCModelF90SampleMaker::DCModelF90SampleProcMaker.new
    dcsampleproc1_expected = <<-EOF
  subroutine DcmodelSampleCodeCalculation( dcm_sam_cod, err )
    !--
    ! Describe brief of DcmodelSampleCodeCalculation
    !++
    ! If *dcm_sam_cod* is not initialized by Create yet,
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
    implicit none
    type(DCMSAMCOD), intent(inout):: dcm_sam_cod
    logical, intent(out), optional:: err
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

!!$    integer:: param_i
!!$    real(DP):: param_r
!!$    character(STRING):: param_c

    !-----------------------------------
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DcmodelSampleCodeCalculation'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. dcm_sam_cod % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'DCMSAMCOD'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  *dcm_sam_cod* ˳ǼƤͤμФ
    !  Fetch setting values stored in *dcm_sam_cod*
    !-----------------------------------------------------------------
!!$    param_i = dcm_sam_cod % param_i
!!$    param_r = dcm_sam_cod % param_r
!!$    param_c = dcm_sam_cod % param_c


    !-----------------------------------------------------------------
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DcmodelSampleCodeCalculation
EOF
    dcsampleproc1_expected_array = dcsampleproc1_expected.split("\n")
    dcsampleproc1.lang_ja = false
    dcsampleproc1_actual_array = dcsampleproc1.to_s.split("\n")
    lineno = 0
    dcsampleproc1_expected_array.each{ |line|
      assert_equal(line, dcsampleproc1_actual_array[lineno], "DCModelF90SampleProcMaker (other) check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }

    dcsample1.no_lang_ja
    dcsample1_actual_array = dcsample1.to_s.split("\n")
    lineno = 0
    dcsampleproc1_expected_array.each{ |line|
      assert_equal(line, dcsample1_actual_array[lineno], "DCModelF90SampleMaker (procedure#other) check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }


    dcsampleproc2 = DCModelF90SampleMaker::DCModelF90SampleProcMaker.new('create')
    dcsampleproc2.set_basename('Dcmodel')
    dcsampleproc2.set_arg_type('DCMOD')
    dcsampleproc2.set_arg_keyword('dc_model')
    dcsampleproc2.set_alreadyinit_err_code('DC_EALREADYINIT')

    dcsampleproc2_expected = <<-EOF
  subroutine DcmodelCreate( dc_model, &
!!$    & param_i, param_r, param_c, &
    & nmlfile, err )
    !
    ! Constructor of "DCMOD".
    ! Initialize *dc_model* by this subroutine, 
    ! before other procedures are used, 
    !
    ! Note that if *dc_model* is already initialized 
    ! by this procedure, error is occurred.
    !
    ! In order to use NAMELIST, specify a NAMELIST filename to 
    ! argument *nmlfile*.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_present, only: present_and_not_empty, present_and_true
    use dc_message, only: MessageNotify
    use dc_error, only: StoreError, DC_NOERR, DC_EALREADYINIT, &
      & DC_EARGLACK, DC_ENEGATIVE, DC_ENOFILEREAD
    implicit none
    type(DCMOD), intent(inout):: dc_model
!!$    integer, intent(in):: param_i
!!$    real(DP), intent(in), optional:: param_r
!!$    character(*), intent(in), optional:: param_c
    character(*), intent(in), optional :: nmlfile
                              ! NAMELIST file name. 
                              ! If nonnull character is specified to
                              ! this argument, 
                              ! NAMELIST group name is loaded from the 
                              ! file. 
                              ! If the file can not be read, 
                              ! an error occurs.
                              ! 
    logical, intent(out), optional:: err
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DcmodelCreate'
  continue
    call BeginSub( subname, version )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Check initialization
    !-----------------------------------------------------------------
    if ( dc_model % initialized ) then
      stat = DC_EALREADYINIT
      cause_c = 'DCMOD'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  Validate arguments
    !-----------------------------------------------------------------
!!$    if ( .not. present(param_r) .and. .not. present(param_c) ) then
!!$      stat = DC_EARGLACK
!!$      cause_c = '"param_r" or "param_c"'
!!$      goto 999
!!$    end if

    !-----------------------------------------------------------------
    !  Configure the settings for "DCMOD"
    !-----------------------------------------------------------------

    !-------------------------
    !  Default values
!!$    dc_model % param_r = 0.0_DP
!!$    dc_model % param_c = 'hogehoge'

    !-------------------------
    !  Values from optional arguments
!!$    dc_model % param_i = param_i
!!$    if ( present(param_r) )  dc_model % param_r = param_r
!!$    if ( present(param_c) )  dc_model % param_c = param_c

    !-------------------------
    !  Values from NAMELIST

!!$    if ( present_and_not_empty(nmlfile) ) then
!!$      call MessageNotify( 'M', subname, &
!!$        & 'Loading NAMELIST file "%c" ...', &
!!$        & c1=trim(nmlfile) )
!!$      call NmlRead ( nmlfile = nmlfile, &      ! (in)
!!$        & param_i = dc_model % param_i, &   ! (inout)
!!$        & param_r = dc_model % param_r, &   ! (inout)
!!$        & param_c_ = dc_model % param_c, &  ! (inout)
!!$        & err = err )                          ! (out)
!!$      if ( present_and_true(err) ) then
!!$        call MessageNotify( 'W', subname, &
!!$          & '"%c" can not be read.', &
!!$          & c1=trim(nmlfile) )
!!$        stat = DC_ENOFILEREAD
!!$        cause_c = nmlfile
!!$        goto 999
!!$      end if
!!$    end if

    !-----------------------------------------------------------------
    !  Validate setting values
    !-----------------------------------------------------------------
!!$    if ( dc_model % param_i < 0 ) then
!!$      stat = DC_ENEGATIVE
!!$      cause_c = 'param_i'
!!$      goto 999
!!$    end if


    !-----------------------------------------------------------------
    !  Termination and Exception handling
    !-----------------------------------------------------------------
    dc_model % initialized = .true.
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DcmodelCreate
EOF
    dcsampleproc2_expected_array = dcsampleproc2_expected.split("\n")
    dcsampleproc2.lang_ja = false
    dcsampleproc2_actual_array = dcsampleproc2.to_s.split("\n")
    lineno = 0
    dcsampleproc2_expected_array.each{ |line|
      assert_equal(line, dcsampleproc2_actual_array[lineno], "DCModelF90SampleProcMaker (create) check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }


    dcsampleproc3 = DCModelF90SampleMaker::DCModelF90SampleProcMaker.new('putline')
    dcsampleproc3_expected = <<-EOF
  subroutine DcmodelSampleCodePutLine( dcm_sam_cod, unit, indent, err )
    !
    ! Print information of *dcm_sam_cod*.
    ! By default messages are output to standard output.
    ! Unit number for output can be changed by *unit* argument.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
    use dc_string, only: Printf
    implicit none
    type(DCMSAMCOD), intent(in):: dcm_sam_cod
    integer, intent(in), optional:: unit
                              ! Unit number for output.
                              ! Default value is standard output.
    character(*), intent(in), optional:: indent
                              ! Indent of displayed messages.
    logical, intent(out), optional:: err
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    integer:: out_unit
    integer:: indent_len
    character(STRING):: indent_str
    character(*), parameter:: subname = 'DcmodelSampleCodePutLine'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Check initialization
    !-----------------------------------------------------------------
    if ( present(unit) ) then
      out_unit = unit
    else
      out_unit = STDOUT
    end if

    indent_len = 0
    indent_str = ''
    if ( present(indent) ) then
      if ( len(indent) /= 0 ) then
        indent_len = len(indent)
        indent_str(1:indent_len) = indent
      end if
    end if


    !-----------------------------------------------------------------
    !  Print the settings for "DCMSAMCOD"
    !-----------------------------------------------------------------
    if ( dcm_sam_cod % initialized ) then
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '#<DCMSAMCOD:: @initialized=%y', &
        & l=(/dcm_sam_cod % initialized/))
!!$      call Printf(out_unit, &
!!$        & indent_str(1:indent_len) // &
!!$        & ' @param_i=%d @param_r=%f @param_c=%c', &
!!$        & i=(/dcm_sam_cod % param_i/), &
!!$        & d=(/dcm_sam_cod % param_r/), &
!!$        & c1=trim(dcm_sam_cod % param_c) )
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '>' )
    else
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '#<DCMSAMCOD:: @initialized=%y>', &
        & l=(/dcm_sam_cod % initialized/))
    end if

    !-----------------------------------------------------------------
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DcmodelSampleCodePutLine
EOF
    dcsampleproc3_expected_array = dcsampleproc3_expected.split("\n")
    dcsampleproc3.lang_ja = false
    dcsampleproc3_actual_array = dcsampleproc3.to_s.split("\n")
    lineno = 0
    dcsampleproc3_expected_array.each{ |line|
      assert_equal(line, dcsampleproc3_actual_array[lineno], "DCModelF90SampleProcMaker (putline) check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }


    dcsample2 = DCModelF90SampleMaker.new('module')
    dcsample2_expected = <<-EOF
!= Title
!
! Authors::   unknown
! Version::   $#{}I#{}d: $
! Tag Name::  $#{}N#{}ame:  $
! Copyright:: Copyright (C) GFD Dennou Club, #{Time.now.strftime("%Y")}. All rights reserved.
! License::   
!

module dcmodel_sample_code
  !
  != Title
  !
  ! Overview of Modules
  !
  !== Procedures List
  !
  ! Create        :: Constructor of "DCMSAMCOD"
  ! Close         :: Deconstructor of "DCMSAMCOD"
  ! PutLine       :: Print information of "DCMSAMCOD"
  ! initialized   :: Check initialization of "DCMSAMCOD"
  !
  !== Usage
  !
  ! First, initialize "DCMSAMCOD" by Create.
  !--
  ! Describe usage of module
  !++
  ! In order to terminate "DCMSAMCOD", use Close.
  !

  use dc_types, only: DP, TOKEN
  implicit none
  private
  public:: DCMSAMCOD, Create, Close, PutLine, initialized

  type DCMSAMCOD
    !
    ! Initialize "DCMSAMCOD" variable by "Create" before usage.
    ! If you reuse "DCMSAMCOD" variable again for another application, 
    ! terminate by "Close".
    !
    logical:: initialized = .false.     ! Initialization flag

!!$    integer:: param_i
!!$    real(DP):: param_r
!!$    character(TOKEN):: param_c
  end type DCMSAMCOD

  character(*), parameter:: version = &
    & '$Name: dcpam4-20070731 $' // &
    & '$#{}I#{}d: $'

  interface Create
    module procedure DcmodelSampleCodeCreate
  end interface

  interface Close
    module procedure DcmodelSampleCodeClose
  end interface

  interface PutLine
    module procedure DcmodelSampleCodePutLine
  end interface

  interface initialized
    module procedure DcmodelSampleCodeInitialized
  end interface

  interface NmlRead
    module procedure DcmodelSampleCodeNmlRead
  end interface

!!$  interface Sample
!!$    module procedure DcmodelSampleCodeSample
!!$  end interface

contains

  subroutine DcmodelSampleCodeCreate( dcm_sam_cod, &
!!$    & param_i, param_r, param_c, &
    & nmlfile, err )
    !
    ! Constructor of "DCMSAMCOD".
    ! Initialize *dcm_sam_cod* by this subroutine, 
    ! before other procedures are used, 
    !
    ! Note that if *dcm_sam_cod* is already initialized 
    ! by this procedure, error is occurred.
    !
    ! In order to use NAMELIST, specify a NAMELIST filename to 
    ! argument *nmlfile*.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_present, only: present_and_not_empty, present_and_true
    use dc_message, only: MessageNotify
    use dc_error, only: StoreError, DC_NOERR, DC_EALREADYINIT, &
      & DC_EARGLACK, DC_ENEGATIVE, DC_ENOFILEREAD
    implicit none
    type(DCMSAMCOD), intent(inout):: dcm_sam_cod
!!$    integer, intent(in):: param_i
!!$    real(DP), intent(in), optional:: param_r
!!$    character(*), intent(in), optional:: param_c
    character(*), intent(in), optional :: nmlfile
                              ! NAMELIST file name. 
                              ! If nonnull character is specified to
                              ! this argument, 
                              ! NAMELIST group name is loaded from the 
                              ! file. 
                              ! If the file can not be read, 
                              ! an error occurs.
                              ! 
    logical, intent(out), optional:: err
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DcmodelSampleCodeCreate'
  continue
    call BeginSub( subname, version )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Check initialization
    !-----------------------------------------------------------------
    if ( dcm_sam_cod % initialized ) then
      stat = DC_EALREADYINIT
      cause_c = 'DCMSAMCOD'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  Validate arguments
    !-----------------------------------------------------------------
!!$    if ( .not. present(param_r) .and. .not. present(param_c) ) then
!!$      stat = DC_EARGLACK
!!$      cause_c = '"param_r" or "param_c"'
!!$      goto 999
!!$    end if

    !-----------------------------------------------------------------
    !  Configure the settings for "DCMSAMCOD"
    !-----------------------------------------------------------------

    !-------------------------
    !  Default values
!!$    dcm_sam_cod % param_r = 0.0_DP
!!$    dcm_sam_cod % param_c = 'hogehoge'

    !-------------------------
    !  Values from optional arguments
!!$    dcm_sam_cod % param_i = param_i
!!$    if ( present(param_r) )  dcm_sam_cod % param_r = param_r
!!$    if ( present(param_c) )  dcm_sam_cod % param_c = param_c

    !-------------------------
    !  Values from NAMELIST

!!$    if ( present_and_not_empty(nmlfile) ) then
!!$      call MessageNotify( 'M', subname, &
!!$        & 'Loading NAMELIST file "%c" ...', &
!!$        & c1=trim(nmlfile) )
!!$      call NmlRead ( nmlfile = nmlfile, &      ! (in)
!!$        & param_i = dcm_sam_cod % param_i, &   ! (inout)
!!$        & param_r = dcm_sam_cod % param_r, &   ! (inout)
!!$        & param_c_ = dcm_sam_cod % param_c, &  ! (inout)
!!$        & err = err )                          ! (out)
!!$      if ( present_and_true(err) ) then
!!$        call MessageNotify( 'W', subname, &
!!$          & '"%c" can not be read.', &
!!$          & c1=trim(nmlfile) )
!!$        stat = DC_ENOFILEREAD
!!$        cause_c = nmlfile
!!$        goto 999
!!$      end if
!!$    end if

    !-----------------------------------------------------------------
    !  Validate setting values
    !-----------------------------------------------------------------
!!$    if ( dcm_sam_cod % param_i < 0 ) then
!!$      stat = DC_ENEGATIVE
!!$      cause_c = 'param_i'
!!$      goto 999
!!$    end if


    !-----------------------------------------------------------------
    !  Termination and Exception handling
    !-----------------------------------------------------------------
    dcm_sam_cod % initialized = .true.
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DcmodelSampleCodeCreate

  subroutine DcmodelSampleCodeClose( dcm_sam_cod, err )
    !
    ! Deconstructor of "DCMSAMCOD".
    ! Note that if *dcm_sam_cod* is not initialized by Create yet,
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
    implicit none
    type(DCMSAMCOD), intent(inout):: dcm_sam_cod
    logical, intent(out), optional:: err
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DcmodelSampleCodeClose'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. dcm_sam_cod % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'DCMSAMCOD'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  Clear the settings for "DCMSAMCOD"
    !-----------------------------------------------------------------


    !-----------------------------------------------------------------
    !  Termination and Exception handling
    !-----------------------------------------------------------------
    dcm_sam_cod % initialized = .false.
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DcmodelSampleCodeClose

  subroutine DcmodelSampleCodePutLine( dcm_sam_cod, unit, indent, err )
    !
    ! Print information of *dcm_sam_cod*.
    ! By default messages are output to standard output.
    ! Unit number for output can be changed by *unit* argument.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
    use dc_string, only: Printf
    implicit none
    type(DCMSAMCOD), intent(in):: dcm_sam_cod
    integer, intent(in), optional:: unit
                              ! Unit number for output.
                              ! Default value is standard output.
    character(*), intent(in), optional:: indent
                              ! Indent of displayed messages.
    logical, intent(out), optional:: err
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    integer:: out_unit
    integer:: indent_len
    character(STRING):: indent_str
    character(*), parameter:: subname = 'DcmodelSampleCodePutLine'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Check initialization
    !-----------------------------------------------------------------
    if ( present(unit) ) then
      out_unit = unit
    else
      out_unit = STDOUT
    end if

    indent_len = 0
    indent_str = ''
    if ( present(indent) ) then
      if ( len(indent) /= 0 ) then
        indent_len = len(indent)
        indent_str(1:indent_len) = indent
      end if
    end if


    !-----------------------------------------------------------------
    !  Print the settings for "DCMSAMCOD"
    !-----------------------------------------------------------------
    if ( dcm_sam_cod % initialized ) then
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '#<DCMSAMCOD:: @initialized=%y', &
        & l=(/dcm_sam_cod % initialized/))
!!$      call Printf(out_unit, &
!!$        & indent_str(1:indent_len) // &
!!$        & ' @param_i=%d @param_r=%f @param_c=%c', &
!!$        & i=(/dcm_sam_cod % param_i/), &
!!$        & d=(/dcm_sam_cod % param_r/), &
!!$        & c1=trim(dcm_sam_cod % param_c) )
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '>' )
    else
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '#<DCMSAMCOD:: @initialized=%y>', &
        & l=(/dcm_sam_cod % initialized/))
    end if

    !-----------------------------------------------------------------
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DcmodelSampleCodePutLine

  logical function DcmodelSampleCodeInitialized( dcm_sam_cod ) result(result)
    !
    ! If *dcm_sam_cod* is initialized, .true. is returned.
    ! If *dcm_sam_cod* is not initialized, .false. is returned.
    !
    implicit none
    type(DCMSAMCOD), intent(in):: dcm_sam_cod
  continue
    result = dcm_sam_cod % initialized
  end function DcmodelSampleCodeInitialized

  subroutine DcmodelSampleCodeNmlRead( nmlfile, &
!!$    & param_i, param_r, param_c_, &
    & err )
    !
    ! This is an internal subroutine to input values from 
    ! NAMELIST file *nmlfile*. This subroutine is expected to be
    ! called by "Create".
    !
    ! A value not specified in NAMELIST file is returned
    ! without change.
    !
    ! If *nmlfile* is empty, or *nmlfile* can not be read, 
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_iounit, only: FileOpen
    use dc_message, only: MessageNotify
    use dc_present, only: present_and_true
    use dc_error, only: StoreError, DC_NOERR, DC_ENOFILEREAD
    implicit none
    character(*), intent(in):: nmlfile
                              ! NAMELIST file name
!!$    integer, intent(inout):: param_i
!!$    real(DP), intent(inout):: param_r
!!$    character(*), intent(inout):: param_c_
!!$    character(TOKEN):: param_c
    logical, intent(out), optional:: err
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

!!$    namelist /dcmodel_sample_code_nml/ &
!!$      & param_i, param_r, param_c
                              ! NAMELIST group name for
                              ! 'dcmodel_sample_code' module.

    !-----------------------------------
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    integer:: unit_nml        ! Unit number for NAMELIST file open
    integer:: iostat_nml      ! IOSTAT of NAMELIST read
    character(*), parameter:: subname = 'DcmodelSampleCodeNmlRead'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''



    !-----------------------------------------------------------------
    !  Substitute character arguments to NAMELIST group
    !-----------------------------------------------------------------
!!$    param_c = param_c_

    !----------------------------------------------------------------
    !  Open NAMELIST file
    !----------------------------------------------------------------
    call FileOpen( unit = unit_nml, & ! (out)
      & file = nmlfile, mode = 'r', & ! (in)
      & err = err )                   ! (out)
    if ( present_and_true(err) ) then
      stat = DC_ENOFILEREAD
      cause_c = nmlfile
      goto 999
    end if


    !-----------------------------------------------------------------
    !  Get NAMELIST group
    !-----------------------------------------------------------------
!!$    read( unit = unit_nml, & ! (in)
!!$      & nml = dcmodel_sample_code_nml, iostat = iostat_nml ) ! (out)
!!$    if ( iostat_nml == 0 ) then
!!$      call MessageNotify( 'M', subname, &
!!$        & 'NAMELIST group "%c" is loaded from "%c".', &
!!$        & c1='dcmodel_sample_code_nml', c2=trim(nmlfile) )
!!$      write(STDOUT, nml = dcmodel_sample_code_nml)
!!$    else
!!$      call MessageNotify( 'W', subname, &
!!$        & 'NAMELIST group "%c" is not found in "%c" (iostat=%d).', &
!!$        & c1='dcmodel_sample_code_nml', c2=trim(nmlfile), &
!!$        & i=(/iostat_nml/) )
!!$    end if

    close( unit_nml )

    !-----------------------------------------------------------------
    !  Substitute NAMELIST group to character arguments
    !-----------------------------------------------------------------
!!$    param_c_ = param_c

    !-----------------------------------------------------------------
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DcmodelSampleCodeNmlRead

!!$  subroutine DcmodelSampleCodeSample( dcm_sam_cod, err )
!!$    !--
!!$    ! Describe brief of DcmodelSampleCodeSample
!!$    !++
!!$    ! If *dcm_sam_cod* is not initialized by Create yet,
!!$    ! error is occurred.
!!$    !
!!$    use dc_trace, only: BeginSub, EndSub
!!$    use dc_types, only: DP, STRING, TOKEN, STDOUT
!!$    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
!!$    implicit none
!!$    type(DCMSAMCOD), intent(inout):: dcm_sam_cod
!!$    logical, intent(out), optional:: err
!!$                              ! Exception handling flag. 
!!$                              ! By default, when error occur in 
!!$                              ! this procedure, the program aborts. 
!!$                              ! If this *err* argument is given, 
!!$                              ! .true. is substituted to *err* and 
!!$                              ! the program does not abort. 
!!$
!!$!!$    integer:: param_i
!!$!!$    real(DP):: param_r
!!$!!$    character(STRING):: param_c
!!$
!!$    !-----------------------------------
!!$    !  Work variables
!!$    integer:: stat
!!$    character(STRING):: cause_c
!!$    character(*), parameter:: subname = 'DcmodelSampleCodeSample'
!!$  continue
!!$    call BeginSub( subname )
!!$    stat = DC_NOERR
!!$    cause_c = ''
!!$
!!$    !-----------------------------------------------------------------
!!$    !  Check initialization
!!$    !-----------------------------------------------------------------
!!$    if ( .not. dcm_sam_cod % initialized ) then
!!$      stat = DC_ENOTINIT
!!$      cause_c = 'DCMSAMCOD'
!!$      goto 999
!!$    end if
!!$
!!$    !-----------------------------------------------------------------
!!$    !  *dcm_sam_cod* ˳ǼƤͤμФ
!!$    !  Fetch setting values stored in *dcm_sam_cod*
!!$    !-----------------------------------------------------------------
!!$!!$    param_i = dcm_sam_cod % param_i
!!$!!$    param_r = dcm_sam_cod % param_r
!!$!!$    param_c = dcm_sam_cod % param_c
!!$
!!$
!!$    !-----------------------------------------------------------------
!!$    !  Termination and Exception handling
!!$    !-----------------------------------------------------------------
!!$999 continue
!!$    call StoreError( stat, subname, err, cause_c )
!!$    call EndSub( subname )
!!$  end subroutine DcmodelSampleCodeSample

end module dcmodel_sample_code
EOF

    dcsample2_expected_array = dcsample2_expected.split("\n")
    dcsample2.no_lang_ja
    dcsample2_actual_array = dcsample2.to_s.split("\n")
    lineno = 0
    dcsample2_expected_array.each{ |line|
      assert_equal(line, dcsample2_actual_array[lineno], "DCModelF90SampleMaker (module) check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }


    dcsampletest1 = DCModelF90SampleMaker::DCModelF90SampleTestMaker.new
    dcsampletest1_expected = <<-EOF
!= dcmodel_sample_code ⥸塼Υƥȥץ
!
!= Test program for "dcmodel_sample_code"
!
! Authors::   unknown
! Version::   $#{}I#{}d: $
! Tag Name::  $#{}N#{}ame:  $
! Copyright:: Copyright (C) GFD Dennou Club, #{Time.now.strftime("%Y")}. All rights reserved.
! License::
!
! <b>Note that Japanese and English are described in parallel.</b>
!
! dcmodel_sample_code ⥸塼ưƥȤԤΥץǤ.
! ΥץबѥǤ뤳, Ӽ¹Ի
! ץबｪλ뤳ȤǧƤ.
!
! This program checks the operation of "dcmodel_sample_code" module.
! Confirm compilation and execution of this program.
!

program dcmodel_sample_code_test
  use dcmodel_sample_code, only: DCMSAMCOD, Create, Close, &
    & PutLine, initialized
  use dc_test, only: AssertEqual
  use dc_types, only: DP, STRING
  use dc_string, only: StoA
  use dc_args, only: ARGS, Open, HelpMsg, Option, Debug, Help, Strict, Close
  implicit none

  !---------------------------------------------------------
  !  ¸ɽ, ǥ̾, °̾
  !  Title of a experiment, name of model, sub-organ
  !---------------------------------------------------------
  character(*), parameter:: title = &
    & 'dcmodel_sample_code_test $Name: dcpam4-20070731 $ :: ' // &
    & 'Test program of "dcmodel_sample_code" module'
  character(*), parameter:: source = &
    & 'dcmodel project: hierarchical numerical models ' // &
    & '(See http://www.gfd-dennou.org/library/dcmodel)'
  character(*), parameter:: institution = &
    & 'GFD Dennou Club (See http://www.gfd-dennou.org)'

  !---------------------------------------------------------
  !  ѿ
  !  Work variables
  !---------------------------------------------------------
  type(ARGS):: arg            ! ޥɥ饤. 
                              ! Command line arguments
  logical:: OPT_namelist      ! -N, --namelist ץ̵ͭ. 
                              ! Existence of '-N', '--namelist' option
  character(STRING):: VAL_namelist
                              ! -N, --namelist ץ. 
                              ! Value of '-N', '--namelist' option
  type(DCMSAMCOD):: dcm_sam_cod00, dcm_sam_cod01, dcm_sam_cod02, dcm_sam_cod03
  logical:: err
continue

  !---------------------------------------------------------
  !  ޥɥ饤ν
  !  Command line arguments handling
  !---------------------------------------------------------
  call Open( arg )
  call HelpMsg( arg, 'Title', title )
  call HelpMsg( arg, 'Usage', &
    & './dcmodel_sample_code_test [Options]' )
  call HelpMsg( arg, 'Source', source )
  call HelpMsg( arg, 'Institution', institution )
  call Option( arg, StoA('-N', '--namelist'), &
    & OPT_namelist, VAL_namelist, help = "NAMELIST filename" )
  call Debug( arg ) ; call Help( arg ) ; call Strict( arg, severe = .true. )
  call Close( arg )

  !---------------------------------------------------------
  !  ƥ
  !  Initialization test
  !---------------------------------------------------------
  call Create( dcm_sam_cod = dcm_sam_cod00 & ! (inout)
!!$    & , param_i = 256, param_r = 98.7_DP &   ! (in)
    & )
  call AssertEqual( 'initialization test 1', &
    & answer = .true., check = initialized(dcm_sam_cod00) )
  call PutLine( dcm_sam_cod = dcm_sam_cod00 ) ! (in)

  call Create( dcm_sam_cod = dcm_sam_cod00, & ! (inout)
!!$    & param_i = 256, param_r = 98.7_DP, &     ! (in)
    & err = err )                             ! (out)
  call AssertEqual( 'initialization test 2', &
    & answer = .true., check = err )
  call PutLine( dcm_sam_cod = dcm_sam_cod00 ) ! (in)

  call Create( dcm_sam_cod = dcm_sam_cod01, & ! (inout)
!!$    & param_i = 256, param_r = 98.7_DP, &     ! (in)
    & nmlfile = VAL_namelist )                ! (in)
  call AssertEqual( 'initialization test 3 (NAMELIST)', &
    & answer = .true., check = initialized(dcm_sam_cod01) )
  call PutLine( dcm_sam_cod = dcm_sam_cod01 ) ! (in)

!!$  call Create( dcm_sam_cod = dcm_sam_cod02, &             ! (inout)
!!$    & param_i = -32, param_r = 0.5_DP, param_c = 'foo', & ! (in)
!!$    & err = err )                                         ! (out)
!!$  call AssertEqual( 'initialization test 4', &
!!$    & answer = .true., check = err )

!!$  call Create( dcm_sam_cod = dcm_sam_cod02, & ! (inout)
!!$    & param_i = 256, &                        ! (in)
!!$    & err = err )                             ! (out)
!!$  call AssertEqual( 'initialization test 5', &
!!$    & answer = .true., check = err )

!!$  call Create( dcm_sam_cod = dcm_sam_cod03, &             ! (inout)
!!$    & param_i = -32, param_r = 0.5_DP, param_c = 'foo', & ! (in)
!!$    & nmlfile = VAL_namelist )                            ! (in)
!!$  call AssertEqual( 'initialization test 6 (NAMELIST)', &
!!$    & answer = .true., check = initialized(dcm_sam_cod03) )
!!$  call PutLine( dcm_sam_cod = dcm_sam_cod03 ) ! (in)

  !---------------------------------------------------------
  !  λƥ
  !  Termination test
  !---------------------------------------------------------
  call Close( dcm_sam_cod = dcm_sam_cod00 ) ! (inout)
  call AssertEqual( 'termination test 1', &
    & answer = .false., check = initialized(dcm_sam_cod00) )
  call PutLine( dcm_sam_cod = dcm_sam_cod00 ) ! (in)

  call Close( dcm_sam_cod = dcm_sam_cod02, & ! (inout)
    & err = err )                            ! (out)
  call AssertEqual( 'termination test 2', &
    & answer = .true., check = err )

end program dcmodel_sample_code_test
EOF

    dcsampletest1_expected_array = dcsampletest1_expected.split("\n")
    dcsampletest1_actual_array = dcsampletest1.to_s.split("\n")
    lineno = 0
    dcsampletest1_expected_array.each{ |line|
      assert_equal(line, dcsampletest1_actual_array[lineno], "DCModelF90SampleTestMaker check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }


    dcsampletestnml1 = DCModelF90SampleMaker::DCModelF90SampleTestNmlMaker.new
    dcsampletestnml1_expected = <<-EOF
#= dcmodel_sample_code ⥸塼Υƥȥץ NAMELIST ե
#
#= NAMELIST file for test program of "dcmodel_sample_code"
#
# Authors::   unknown
# Version::   $#{}I#{}d: $
# Tag Name::  $#{}N#{}ame:  $
# Copyright:: Copyright (C) GFD Dennou Club, #{Time.now.strftime("%Y")}. All rights reserved.
# License::
#
&dcmodel_sample_code_nml
 param_i=123,
 param_r=9872.0,
 param_c='herohero'
/
EOF

    dcsampletestnml1_expected_array = dcsampletestnml1_expected.split("\n")
    dcsampletestnml1_actual_array = dcsampletestnml1.to_s.split("\n")
    lineno = 0
    dcsampletestnml1_expected_array.each{ |line|
      assert_equal(line, dcsampletestnml1_actual_array[lineno], "DCModelF90SampleTestNmlMaker check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }


    dcsampletestsh1 = DCModelF90SampleMaker::DCModelF90SampleTestShMaker.new
    dcsampletestsh1_expected = <<-EOF
#!/bin/sh
#
#= Compile and Execute test program of "dcmodel_sample_code"
#
# Authors::   unknown
# Version::   $#{}I#{}d: $
# Tag Name::  $#{}N#{}ame:  $
# Copyright:: Copyright (C) GFD Dennou Club, #{Time.now.strftime("%Y")}. All rights reserved.
# License::
#
######################################################################
#
#== Settings

test -n "$TEST_BASE" || TEST_BASE="dcmodel_sample_code"
TEST_OBJ="${TEST_BASE}.f90 ${TEST_BASE}_test.f90"
TEST_EXEC="${TEST_BASE}_test"
TEST_NML00="${TEST_BASE}_test00.nml"

test -n "$LINKF" || LINKF=gt4frt
#test -n "$MAKE" || MAKE=make

# End Settings
######################################################################

set -e

case `echo "testing\\c"; echo 1,2,3`,`echo -n testing; echo 1,2,3` in
  *c*,-n*) ECHO_N= ECHO_C='
' ECHO_T='      ' ;;
  *c*,*  ) ECHO_N=-n ECHO_C= ECHO_T= ;;
  *)       ECHO_N= ECHO_C='\\c' ECHO_T= ;;
esac

echo ""
echo "****** ${TEST_BASE} Test ******"
echo " in \\"`pwd`\\""

echo " Compiling and Linking ... "
if [ -n "${LINKF}" ]; then
    echo "   ${LINKF} ${TEST_OBJ} -o ${TEST_EXEC}"
    ${LINKF} ${TEST_OBJ} -o ${TEST_EXEC}
else
    ${MAKE} ${TEST_EXEC}
fi
echo " done . "

if [ ! "$CROSS_COMPILING" = "yes" ] && [ ! "$CROSS_COMPILING" = "maybe" ] ; then
    echo "./${TEST_EXEC} --namelist=${TEST_NML00}"
    ./${TEST_EXEC} --namelist=${TEST_NML00}
else
    echo ""
    echo "   WARNING: Cross compile mode will be used."
    echo "            Submit ./${TEST_EXEC}  ."
    echo ""
    exit 1
fi

echo "  *** Test program \\"${TEST_EXEC}\\" becomes successful ***"
exit 0
EOF

    dcsampletestsh1_expected_array = dcsampletestsh1_expected.split("\n")
    dcsampletestsh1_actual_array = dcsampletestsh1.to_s.split("\n")
    lineno = 0
    dcsampletestsh1_expected_array.each{ |line|
      assert_equal(line, dcsampletestsh1_actual_array[lineno], "DCModelF90SampleTestShMaker check 1 :: line: " + lineno.to_s)
      lineno = lineno + 1
    }


  end

end
